ghc-lib-parser-9.10.1.20250103: The GHC API, decoupled from GHC versions

Safe Haskell | Ignore
Language | GHC2021

GHC.Iface.Syntax

Contents

- Binding names

Synopsis

- module GHC.Iface.Type
- data IfaceDecl
  - = IfaceId {
    - ifName :: IfaceTopBndr
    - ifType :: IfaceType
    - ifIdDetails :: IfaceIdDetails
    - ifIdInfo :: IfaceIdInfo
    }
  - | IfaceData {
    - ifName :: IfaceTopBndr
    - ifBinders :: [IfaceTyConBinder]
    - ifResKind :: IfaceType
    - ifCType :: Maybe CType
    - ifRoles :: [Role]
    - ifCtxt :: IfaceContext
    - ifCons :: IfaceConDecls
    - ifGadtSyntax :: Bool
    - ifParent :: IfaceTyConParent
    }
  - | IfaceSynonym {
    - ifName :: IfaceTopBndr
    - ifRoles :: [Role]
    - ifBinders :: [IfaceTyConBinder]
    - ifResKind :: IfaceKind
    - ifSynRhs :: IfaceType
    }
  - | IfaceFamily {
    - ifName :: IfaceTopBndr
    - ifResVar :: Maybe IfLclName
    - ifBinders :: [IfaceTyConBinder]
    - ifResKind :: IfaceKind
    - ifFamFlav :: IfaceFamTyConFlav
    - ifFamInj :: Injectivity
    }
  - | IfaceClass {
    - ifName :: IfaceTopBndr
    - ifRoles :: [Role]
    - ifBinders :: [IfaceTyConBinder]
    - ifFDs :: [FunDep IfLclName]
    - ifBody :: IfaceClassBody
    }
  - | IfaceAxiom {
    - ifName :: IfaceTopBndr
    - ifTyCon :: IfaceTyCon
    - ifRole :: Role
    - ifAxBranches :: [IfaceAxBranch]
    }
  - | IfacePatSyn {
    - ifName :: IfaceTopBndr
    - ifPatIsInfix :: Bool
    - ifPatMatcher :: (IfExtName, Bool)
    - ifPatBuilder :: Maybe (IfExtName, Bool)
    - ifPatUnivBndrs :: [IfaceForAllSpecBndr]
    - ifPatExBndrs :: [IfaceForAllSpecBndr]
    - ifPatProvCtxt :: IfaceContext
    - ifPatReqCtxt :: IfaceContext
    - ifPatArgs :: [IfaceType]
    - ifPatTy :: IfaceType
    - ifFieldLabels :: [FieldLabel]
    }
- data IfaceFamTyConFlav
  - = IfaceDataFamilyTyCon
  - | IfaceOpenSynFamilyTyCon
  - | IfaceClosedSynFamilyTyCon (Maybe (IfExtName, [IfaceAxBranch]))
  - | IfaceAbstractClosedSynFamilyTyCon
  - | IfaceBuiltInSynFamTyCon
- data IfaceClassOp = IfaceClassOp IfaceTopBndr IfaceType (Maybe (DefMethSpec IfaceType))
- data IfaceAT = IfaceAT IfaceDecl (Maybe IfaceType)
- data IfaceConDecl = IfCon {
  - ifConName :: IfaceTopBndr
  - ifConWrapper :: Bool
  - ifConInfix :: Bool
  - ifConExTCvs :: [IfaceBndr]
  - ifConUserTvBinders :: [IfaceForAllSpecBndr]
  - ifConEqSpec :: IfaceEqSpec
  - ifConCtxt :: IfaceContext
  - ifConArgTys :: [(IfaceMult, IfaceType)]
  - ifConFields :: [FieldLabel]
  - ifConStricts :: [IfaceBang]
  - ifConSrcStricts :: [IfaceSrcBang]
  }
- data IfaceConDecls
  - = IfAbstractTyCon
  - | IfDataTyCon !Bool [IfaceConDecl]
  - | IfNewTyCon IfaceConDecl
- type IfaceEqSpec = [(IfLclName, IfaceType)]
- data IfaceExpr
  - = IfaceLcl IfLclName
  - | IfaceExt IfExtName
  - | IfaceType IfaceType
  - | IfaceCo IfaceCoercion
  - | IfaceTuple TupleSort [IfaceExpr]
  - | IfaceLam IfaceLamBndr IfaceExpr
  - | IfaceApp IfaceExpr IfaceExpr
  - | IfaceCase IfaceExpr IfLclName [IfaceAlt]
  - | IfaceECase IfaceExpr IfaceType
  - | IfaceLet (IfaceBinding IfaceLetBndr) IfaceExpr
  - | IfaceCast IfaceExpr IfaceCoercion
  - | IfaceLit Literal
  - | IfaceLitRubbish TypeOrConstraint IfaceType
  - | IfaceFCall ForeignCall IfaceType
  - | IfaceTick IfaceTickish IfaceExpr
- data IfaceAlt = IfaceAlt IfaceConAlt [IfLclName] IfaceExpr
- data IfaceLetBndr = IfLetBndr IfLclName IfaceType IfaceIdInfo JoinPointHood
- type IfaceBinding b = IfaceBindingX IfaceExpr b
- data IfaceBindingX r b
  - = IfaceNonRec b r
  - | IfaceRec [(b, r)]
- data IfaceMaybeRhs
  - = IfUseUnfoldingRhs
  - | IfRhs IfaceExpr
- data IfaceConAlt
  - = IfaceDefault
  - | IfaceDataAlt IfExtName
  - | IfaceLitAlt Literal
- type IfaceIdInfo = [IfaceInfoItem]
- data IfaceIdDetails
  - = IfVanillaId
  - | IfWorkerLikeId [CbvMark]
  - | IfRecSelId {
    - ifRecSelIdParent :: Either IfaceTyCon IfaceDecl
    - ifRecSelFirstCon :: IfaceTopBndr
    - ifRecSelIdIsNaughty :: Bool
    - ifRecSelIdFieldLabel :: FieldLabel
    }
  - | IfDFunId
- data IfaceUnfolding
  - = IfCoreUnfold UnfoldingSource IfUnfoldingCache IfGuidance IfaceExpr
  - | IfDFunUnfold [IfaceBndr] [IfaceExpr]
- data IfGuidance
  - = IfNoGuidance
  - | IfWhen Arity Bool Bool
- data IfaceInfoItem
  - = HsArity Arity
  - | HsDmdSig DmdSig
  - | HsCprSig CprSig
  - | HsInline InlinePragma
  - | HsUnfold Bool IfaceUnfolding
  - | HsNoCafRefs
  - | HsLFInfo IfaceLFInfo
  - | HsTagSig TagSig
- data IfaceRule = IfaceRule {
  - ifRuleName :: RuleName
  - ifActivation :: Activation
  - ifRuleBndrs :: [IfaceBndr]
  - ifRuleHead :: IfExtName
  - ifRuleArgs :: [IfaceExpr]
  - ifRuleRhs :: IfaceExpr
  - ifRuleAuto :: Bool
  - ifRuleOrph :: IsOrphan
  }
- data IfaceAnnotation = IfaceAnnotation {
  - ifAnnotatedTarget :: IfaceAnnTarget
  - ifAnnotatedValue :: AnnPayload
  }
- type IfaceAnnTarget = AnnTarget OccName
- data IfaceWarnings
  - = IfWarnAll IfaceWarningTxt
  - | IfWarnSome [(OccName, IfaceWarningTxt)] [(IfExtName, IfaceWarningTxt)]
- data IfaceWarningTxt
  - = IfWarningTxt (Maybe WarningCategory) SourceText [(IfaceStringLiteral, [IfExtName])]
  - | IfDeprecatedTxt SourceText [(IfaceStringLiteral, [IfExtName])]
- data IfaceStringLiteral = IfStringLiteral SourceText FastString
- data IfaceClsInst = IfaceClsInst {
  - ifInstCls :: IfExtName
  - ifInstTys :: [Maybe IfaceTyCon]
  - ifDFun :: IfExtName
  - ifOFlag :: OverlapFlag
  - ifInstOrph :: IsOrphan
  - ifInstWarn :: Maybe IfaceWarningTxt
  }
- data IfaceFamInst = IfaceFamInst {
  - ifFamInstFam :: IfExtName
  - ifFamInstTys :: [Maybe IfaceTyCon]
  - ifFamInstAxiom :: IfExtName
  - ifFamInstOrph :: IsOrphan
  }
- data IfaceTickish
  - = IfaceHpcTick Module Int
  - | IfaceSCC CostCentre Bool Bool
  - | IfaceSource RealSrcSpan FastString
  - | IfaceBreakpoint Int [IfaceExpr] Module
- data IfaceClassBody
  - = IfAbstractClass
  - | IfConcreteClass {
    - ifClassCtxt :: IfaceContext
    - ifATs :: [IfaceAT]
    - ifSigs :: [IfaceClassOp]
    - ifMinDef :: IfaceBooleanFormula
    }
- data IfaceBooleanFormula
  - = IfVar IfLclName
  - | IfAnd [IfaceBooleanFormula]
  - | IfOr [IfaceBooleanFormula]
  - | IfParens IfaceBooleanFormula
- data IfaceBang
  - = IfNoBang
  - | IfStrict
  - | IfUnpack
  - | IfUnpackCo IfaceCoercion
- data IfaceSrcBang = IfSrcBang SrcUnpackedness SrcStrictness
- data SrcUnpackedness
  - = SrcUnpack
  - | SrcNoUnpack
  - | NoSrcUnpack
- data SrcStrictness
  - = SrcLazy
  - | SrcStrict
  - | NoSrcStrict
- data IfaceAxBranch = IfaceAxBranch {
  - ifaxbTyVars :: [IfaceTvBndr]
  - ifaxbEtaTyVars :: [IfaceTvBndr]
  - ifaxbCoVars :: [IfaceIdBndr]
  - ifaxbLHS :: IfaceAppArgs
  - ifaxbRoles :: [Role]
  - ifaxbRHS :: IfaceType
  - ifaxbIncomps :: [BranchIndex]
  }
- data IfaceTyConParent
  - = IfNoParent
  - | IfDataInstance IfExtName IfaceTyCon IfaceAppArgs
- data IfaceCompleteMatch = IfaceCompleteMatch [IfExtName] (Maybe IfaceTyCon)
- data IfaceLFInfo
  - = IfLFReEntrant !RepArity
  - | IfLFThunk !Bool !Bool
  - | IfLFCon !Name
  - | IfLFUnknown !Bool
  - | IfLFUnlifted
- data IfaceTopBndrInfo
  - = IfLclTopBndr IfLclName IfaceType IfaceIdInfo IfaceIdDetails
  - | IfGblTopBndr IfaceTopBndr
- type IfaceTopBndr = Name
- putIfaceTopBndr :: BinHandle -> IfaceTopBndr -> IO ()
- getIfaceTopBndr :: BinHandle -> IO IfaceTopBndr
- ifaceDeclImplicitBndrs :: IfaceDecl -> [OccName]
- visibleIfConDecls :: IfaceConDecls -> [IfaceConDecl]
- ifaceDeclFingerprints :: Fingerprint -> IfaceDecl -> [(OccName, Fingerprint)]
- fromIfaceBooleanFormula :: IfaceBooleanFormula -> BooleanFormula IfLclName
- fromIfaceWarnings :: IfaceWarnings -> Warnings GhcRn
- fromIfaceWarningTxt :: IfaceWarningTxt -> WarningTxt GhcRn
- freeNamesIfDecl :: IfaceDecl -> NameSet
- freeNamesIfRule :: IfaceRule -> NameSet
- freeNamesIfFamInst :: IfaceFamInst -> NameSet
- freeNamesIfConDecls :: IfaceConDecls -> NameSet
- pprIfaceExpr :: (SDoc -> SDoc) -> IfaceExpr -> SDoc
- pprIfaceDecl :: ShowSub -> IfaceDecl -> SDoc
- newtype AltPpr = AltPpr (Maybe (OccName -> SDoc))
- data ShowSub = ShowSub {
  - ss_how_much :: ShowHowMuch
  - ss_forall :: ShowForAllFlag
  }
- data ShowHowMuch
  - = ShowHeader AltPpr
  - | ShowSome (Maybe (OccName -> Bool)) AltPpr
  - | ShowIface
- showToIface :: ShowSub
- showToHeader :: ShowSub

# Documentation

module GHC.Iface.Type

data IfaceDecl #

Constructors

IfaceId |

Fields

- ifName :: IfaceTopBndr
- ifType :: IfaceType
- ifIdDetails :: IfaceIdDetails
- ifIdInfo :: IfaceIdInfo

IfaceData |

Fields

- ifName :: IfaceTopBndr
- ifBinders :: [IfaceTyConBinder]
- ifResKind :: IfaceType
- ifCType :: Maybe CType
- ifRoles :: [Role]
- ifCtxt :: IfaceContext
- ifCons :: IfaceConDecls
- ifGadtSyntax :: Bool
- ifParent :: IfaceTyConParent

IfaceSynonym |

Fields

- ifName :: IfaceTopBndr
- ifRoles :: [Role]
- ifBinders :: [IfaceTyConBinder]
- ifResKind :: IfaceKind
- ifSynRhs :: IfaceType

IfaceFamily |

Fields

- ifName :: IfaceTopBndr
- ifResVar :: Maybe IfLclName
- ifBinders :: [IfaceTyConBinder]
- ifResKind :: IfaceKind
- ifFamFlav :: IfaceFamTyConFlav
- ifFamInj :: Injectivity

IfaceClass |

Fields

- ifName :: IfaceTopBndr
- ifRoles :: [Role]
- ifBinders :: [IfaceTyConBinder]
- ifFDs :: [FunDep IfLclName]
- ifBody :: IfaceClassBody

IfaceAxiom |

Fields

- ifName :: IfaceTopBndr
- ifTyCon :: IfaceTyCon
- ifRole :: Role
- ifAxBranches :: [IfaceAxBranch]

IfacePatSyn |

Fields

- ifName :: IfaceTopBndr
- ifPatIsInfix :: Bool
- ifPatMatcher :: (IfExtName, Bool)
- ifPatBuilder :: Maybe (IfExtName, Bool)
- ifPatUnivBndrs :: [IfaceForAllSpecBndr]
- ifPatExBndrs :: [IfaceForAllSpecBndr]
- ifPatProvCtxt :: IfaceContext
- ifPatReqCtxt :: IfaceContext
- ifPatArgs :: [IfaceType]
- ifPatTy :: IfaceType
- ifFieldLabels :: [FieldLabel]

#### Instances

Instances details

NFData IfaceDecl # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceDecl -> () #
NamedThing IfaceDecl # |
Instance details Defined in GHC.Iface.Syntax Methods getOccName :: IfaceDecl -> OccName # getName :: IfaceDecl -> Name #
HasOccName IfaceDecl # |
Instance details Defined in GHC.Iface.Syntax Methods occName :: IfaceDecl -> OccName #
Binary IfaceDecl # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceDecl -> IO () # put :: BinHandle -> IfaceDecl -> IO (Bin IfaceDecl) # get :: BinHandle -> IO IfaceDecl #
Outputable IfaceDecl # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceDecl -> SDoc #

data IfaceFamTyConFlav #

Constructors

IfaceDataFamilyTyCon |
IfaceOpenSynFamilyTyCon |
IfaceClosedSynFamilyTyCon (Maybe (IfExtName, [IfaceAxBranch])) | Name of associated axiom and branches for pretty printing purposes, or `Nothing` for an empty closed family without an axiom See Note [Pretty printing via Iface syntax] in GHC.Types.TyThing.Ppr
IfaceAbstractClosedSynFamilyTyCon |
IfaceBuiltInSynFamTyCon |

#### Instances

Instances details

NFData IfaceFamTyConFlav # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceFamTyConFlav -> () #
Binary IfaceFamTyConFlav # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceFamTyConFlav -> IO () # put :: BinHandle -> IfaceFamTyConFlav -> IO (Bin IfaceFamTyConFlav) # get :: BinHandle -> IO IfaceFamTyConFlav #

data IfaceClassOp #

Constructors

IfaceClassOp IfaceTopBndr IfaceType (Maybe (DefMethSpec IfaceType)) |

#### Instances

Instances details

NFData IfaceClassOp # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceClassOp -> () #
NamedThing IfaceClassOp # |
Instance details Defined in GHC.Iface.Syntax Methods getOccName :: IfaceClassOp -> OccName # getName :: IfaceClassOp -> Name #
HasOccName IfaceClassOp # |
Instance details Defined in GHC.Iface.Syntax Methods occName :: IfaceClassOp -> OccName #
Binary IfaceClassOp # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceClassOp -> IO () # put :: BinHandle -> IfaceClassOp -> IO (Bin IfaceClassOp) # get :: BinHandle -> IO IfaceClassOp #
Outputable IfaceClassOp # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceClassOp -> SDoc #

data IfaceAT #

Constructors

IfaceAT IfaceDecl (Maybe IfaceType) |

#### Instances

Instances details

NFData IfaceAT # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceAT -> () #
Binary IfaceAT # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceAT -> IO () # put :: BinHandle -> IfaceAT -> IO (Bin IfaceAT) # get :: BinHandle -> IO IfaceAT #
Outputable IfaceAT # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceAT -> SDoc #

data IfaceConDecl #

Constructors

IfCon |

Fields

- ifConName :: IfaceTopBndr
- ifConWrapper :: Bool
- ifConInfix :: Bool
- ifConExTCvs :: [IfaceBndr]
- ifConUserTvBinders :: [IfaceForAllSpecBndr]
- ifConEqSpec :: IfaceEqSpec
- ifConCtxt :: IfaceContext
- ifConArgTys :: [(IfaceMult, IfaceType)]
- ifConFields :: [FieldLabel]
- ifConStricts :: [IfaceBang]
- ifConSrcStricts :: [IfaceSrcBang]

#### Instances

Instances details

NFData IfaceConDecl # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceConDecl -> () #
NamedThing IfaceConDecl # |
Instance details Defined in GHC.Iface.Syntax Methods getOccName :: IfaceConDecl -> OccName # getName :: IfaceConDecl -> Name #
HasOccName IfaceConDecl # |
Instance details Defined in GHC.Iface.Syntax Methods occName :: IfaceConDecl -> OccName #
Binary IfaceConDecl # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceConDecl -> IO () # put :: BinHandle -> IfaceConDecl -> IO (Bin IfaceConDecl) # get :: BinHandle -> IO IfaceConDecl #

data IfaceConDecls #

Constructors

IfAbstractTyCon |
IfDataTyCon !Bool [IfaceConDecl] |
IfNewTyCon IfaceConDecl |

#### Instances

Instances details

NFData IfaceConDecls # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceConDecls -> () #
Binary IfaceConDecls # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceConDecls -> IO () # put :: BinHandle -> IfaceConDecls -> IO (Bin IfaceConDecls) # get :: BinHandle -> IO IfaceConDecls #

type IfaceEqSpec = [(IfLclName, IfaceType)] #

data IfaceExpr #

Constructors

IfaceLcl IfLclName |
IfaceExt IfExtName |
IfaceType IfaceType |
IfaceCo IfaceCoercion |
IfaceTuple TupleSort [IfaceExpr] |
IfaceLam IfaceLamBndr IfaceExpr |
IfaceApp IfaceExpr IfaceExpr |
IfaceCase IfaceExpr IfLclName [IfaceAlt] |
IfaceECase IfaceExpr IfaceType |
IfaceLet (IfaceBinding IfaceLetBndr) IfaceExpr |
IfaceCast IfaceExpr IfaceCoercion |
IfaceLit Literal |
IfaceLitRubbish TypeOrConstraint IfaceType |
IfaceFCall ForeignCall IfaceType |
IfaceTick IfaceTickish IfaceExpr |

#### Instances

Instances details

NFData IfaceExpr # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceExpr -> () #
Binary IfaceExpr # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceExpr -> IO () # put :: BinHandle -> IfaceExpr -> IO (Bin IfaceExpr) # get :: BinHandle -> IO IfaceExpr #
Outputable IfaceExpr # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceExpr -> SDoc #

data IfaceAlt #

Constructors

IfaceAlt IfaceConAlt [IfLclName] IfaceExpr |

#### Instances

Instances details

NFData IfaceAlt # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceAlt -> () #
Binary IfaceAlt # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceAlt -> IO () # put :: BinHandle -> IfaceAlt -> IO (Bin IfaceAlt) # get :: BinHandle -> IO IfaceAlt #

data IfaceLetBndr #

Constructors

IfLetBndr IfLclName IfaceType IfaceIdInfo JoinPointHood |

#### Instances

Instances details

NFData IfaceLetBndr # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceLetBndr -> () #
Binary IfaceLetBndr # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceLetBndr -> IO () # put :: BinHandle -> IfaceLetBndr -> IO (Bin IfaceLetBndr) # get :: BinHandle -> IO IfaceLetBndr #

type IfaceBinding b = IfaceBindingX IfaceExpr b #

data IfaceBindingX r b #

Constructors

IfaceNonRec b r |
IfaceRec [(b, r)] |

#### Instances

Instances details

Functor (IfaceBindingX r) # |
Instance details Defined in GHC.Iface.Syntax Methods fmap :: (a -> b) -> IfaceBindingX r a -> IfaceBindingX r b # (<$) :: a -> IfaceBindingX r b -> IfaceBindingX r a #
Foldable (IfaceBindingX r) # |

Instance details

Defined in GHC.Iface.Syntax

Methods

fold :: Monoid m => IfaceBindingX r m -> m #

foldMap :: Monoid m => (a -> m) -> IfaceBindingX r a -> m #

foldMap' :: Monoid m => (a -> m) -> IfaceBindingX r a -> m #

foldr :: (a -> b -> b) -> b -> IfaceBindingX r a -> b #

foldr' :: (a -> b -> b) -> b -> IfaceBindingX r a -> b #

foldl :: (b -> a -> b) -> b -> IfaceBindingX r a -> b #

foldl' :: (b -> a -> b) -> b -> IfaceBindingX r a -> b #

foldr1 :: (a -> a -> a) -> IfaceBindingX r a -> a #

foldl1 :: (a -> a -> a) -> IfaceBindingX r a -> a #

toList :: IfaceBindingX r a -> [a] #

null :: IfaceBindingX r a -> Bool #

length :: IfaceBindingX r a -> Int #

elem :: Eq a => a -> IfaceBindingX r a -> Bool #

maximum :: Ord a => IfaceBindingX r a -> a #

minimum :: Ord a => IfaceBindingX r a -> a #

sum :: Num a => IfaceBindingX r a -> a #

product :: Num a => IfaceBindingX r a -> a #

Traversable (IfaceBindingX r) # |
Instance details Defined in GHC.Iface.Syntax Methods traverse :: Applicative f => (a -> f b) -> IfaceBindingX r a -> f (IfaceBindingX r b) # sequenceA :: Applicative f => IfaceBindingX r (f a) -> f (IfaceBindingX r a) # mapM :: Monad m => (a -> m b) -> IfaceBindingX r a -> m (IfaceBindingX r b) # sequence :: Monad m => IfaceBindingX r (m a) -> m (IfaceBindingX r a) #
(NFData b, NFData a) => NFData (IfaceBindingX a b) # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceBindingX a b -> () #
(Binary r, Binary b) => Binary (IfaceBindingX b r) # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceBindingX b r -> IO () # put :: BinHandle -> IfaceBindingX b r -> IO (Bin (IfaceBindingX b r)) # get :: BinHandle -> IO (IfaceBindingX b r) #
(Outputable r, Outputable b) => Outputable (IfaceBindingX r b) # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceBindingX r b -> SDoc #
(Eq b, Eq r) => Eq (IfaceBindingX r b) # |
Instance details Defined in GHC.Iface.Syntax Methods (==) :: IfaceBindingX r b -> IfaceBindingX r b -> Bool # (/=) :: IfaceBindingX r b -> IfaceBindingX r b -> Bool #
(Ord b, Ord r) => Ord (IfaceBindingX r b) # |

Instance details

Defined in GHC.Iface.Syntax

Methods

compare :: IfaceBindingX r b -> IfaceBindingX r b -> Ordering #

(<) :: IfaceBindingX r b -> IfaceBindingX r b -> Bool #

(<=) :: IfaceBindingX r b -> IfaceBindingX r b -> Bool #

(>) :: IfaceBindingX r b -> IfaceBindingX r b -> Bool #

(>=) :: IfaceBindingX r b -> IfaceBindingX r b -> Bool #

max :: IfaceBindingX r b -> IfaceBindingX r b -> IfaceBindingX r b #

min :: IfaceBindingX r b -> IfaceBindingX r b -> IfaceBindingX r b #

data IfaceMaybeRhs #

Constructors

IfUseUnfoldingRhs |
IfRhs IfaceExpr |

#### Instances

Instances details

NFData IfaceMaybeRhs # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceMaybeRhs -> () #
Binary IfaceMaybeRhs # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceMaybeRhs -> IO () # put :: BinHandle -> IfaceMaybeRhs -> IO (Bin IfaceMaybeRhs) # get :: BinHandle -> IO IfaceMaybeRhs #
Outputable IfaceMaybeRhs # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceMaybeRhs -> SDoc #

data IfaceConAlt #

Constructors

IfaceDefault |
IfaceDataAlt IfExtName |
IfaceLitAlt Literal |

#### Instances

Instances details

NFData IfaceConAlt # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceConAlt -> () #
Binary IfaceConAlt # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceConAlt -> IO () # put :: BinHandle -> IfaceConAlt -> IO (Bin IfaceConAlt) # get :: BinHandle -> IO IfaceConAlt #
Outputable IfaceConAlt # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceConAlt -> SDoc #

type IfaceIdInfo = [IfaceInfoItem] #

data IfaceIdDetails #

Constructors

IfVanillaId |
IfWorkerLikeId [CbvMark] |
IfRecSelId |

Fields

- ifRecSelIdParent :: Either IfaceTyCon IfaceDecl
- ifRecSelFirstCon :: IfaceTopBndr
- ifRecSelIdIsNaughty :: Bool
- ifRecSelIdFieldLabel :: FieldLabel

IfDFunId |

#### Instances

Instances details

NFData IfaceIdDetails # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceIdDetails -> () #
Binary IfaceIdDetails # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceIdDetails -> IO () # put :: BinHandle -> IfaceIdDetails -> IO (Bin IfaceIdDetails) # get :: BinHandle -> IO IfaceIdDetails #
Outputable IfaceIdDetails # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceIdDetails -> SDoc #

data IfaceUnfolding #

Constructors

IfCoreUnfold UnfoldingSource IfUnfoldingCache IfGuidance IfaceExpr |
IfDFunUnfold [IfaceBndr] [IfaceExpr] |

#### Instances

Instances details

NFData IfaceUnfolding # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceUnfolding -> () #
Binary IfaceUnfolding # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceUnfolding -> IO () # put :: BinHandle -> IfaceUnfolding -> IO (Bin IfaceUnfolding) # get :: BinHandle -> IO IfaceUnfolding #
Outputable IfaceUnfolding # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceUnfolding -> SDoc #

data IfGuidance #

Constructors

IfNoGuidance |
IfWhen Arity Bool Bool |

#### Instances

Instances details

NFData IfGuidance # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfGuidance -> () #
Binary IfGuidance # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfGuidance -> IO () # put :: BinHandle -> IfGuidance -> IO (Bin IfGuidance) # get :: BinHandle -> IO IfGuidance #
Outputable IfGuidance # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfGuidance -> SDoc #

data IfaceInfoItem #

Constructors

HsArity Arity |
HsDmdSig DmdSig |
HsCprSig CprSig |
HsInline InlinePragma |
HsUnfold Bool IfaceUnfolding |
HsNoCafRefs |
HsLFInfo IfaceLFInfo |
HsTagSig TagSig |

#### Instances

Instances details

NFData IfaceInfoItem # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceInfoItem -> () #
Binary IfaceInfoItem # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceInfoItem -> IO () # put :: BinHandle -> IfaceInfoItem -> IO (Bin IfaceInfoItem) # get :: BinHandle -> IO IfaceInfoItem #
Outputable IfaceInfoItem # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceInfoItem -> SDoc #

data IfaceRule #

Constructors

IfaceRule |

Fields

- ifRuleName :: RuleName
- ifActivation :: Activation
- ifRuleBndrs :: [IfaceBndr]
- ifRuleHead :: IfExtName
- ifRuleArgs :: [IfaceExpr]
- ifRuleRhs :: IfaceExpr
- ifRuleAuto :: Bool
- ifRuleOrph :: IsOrphan

#### Instances

Instances details

NFData IfaceRule # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceRule -> () #
Binary IfaceRule # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceRule -> IO () # put :: BinHandle -> IfaceRule -> IO (Bin IfaceRule) # get :: BinHandle -> IO IfaceRule #
Outputable IfaceRule # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceRule -> SDoc #

data IfaceAnnotation #

Constructors

IfaceAnnotation |

Fields

- ifAnnotatedTarget :: IfaceAnnTarget
- ifAnnotatedValue :: AnnPayload

#### Instances

Instances details

NFData IfaceAnnotation # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceAnnotation -> () #
Binary IfaceAnnotation # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceAnnotation -> IO () # put :: BinHandle -> IfaceAnnotation -> IO (Bin IfaceAnnotation) # get :: BinHandle -> IO IfaceAnnotation #
Outputable IfaceAnnotation # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceAnnotation -> SDoc #

type IfaceAnnTarget = AnnTarget OccName #

data IfaceWarnings #

Constructors

IfWarnAll IfaceWarningTxt |
IfWarnSome [(OccName, IfaceWarningTxt)] [(IfExtName, IfaceWarningTxt)] |

#### Instances

Instances details

NFData IfaceWarnings # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceWarnings -> () #
Binary IfaceWarnings # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceWarnings -> IO () # put :: BinHandle -> IfaceWarnings -> IO (Bin IfaceWarnings) # get :: BinHandle -> IO IfaceWarnings #
Outputable IfaceWarnings # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceWarnings -> SDoc #

data IfaceWarningTxt #

Constructors

IfWarningTxt (Maybe WarningCategory) SourceText [(IfaceStringLiteral, [IfExtName])] |
IfDeprecatedTxt SourceText [(IfaceStringLiteral, [IfExtName])] |

#### Instances

Instances details

NFData IfaceWarningTxt # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceWarningTxt -> () #
Binary IfaceWarningTxt # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceWarningTxt -> IO () # put :: BinHandle -> IfaceWarningTxt -> IO (Bin IfaceWarningTxt) # get :: BinHandle -> IO IfaceWarningTxt #
Outputable IfaceWarningTxt # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceWarningTxt -> SDoc #

data IfaceStringLiteral #

Constructors

IfStringLiteral SourceText FastString |

#### Instances

Instances details

NFData IfaceStringLiteral # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceStringLiteral -> () #
Binary IfaceStringLiteral # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceStringLiteral -> IO () # put :: BinHandle -> IfaceStringLiteral -> IO (Bin IfaceStringLiteral) # get :: BinHandle -> IO IfaceStringLiteral #
Outputable IfaceStringLiteral # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceStringLiteral -> SDoc #

data IfaceClsInst #

Constructors

IfaceClsInst |

Fields

- ifInstCls :: IfExtName
- ifInstTys :: [Maybe IfaceTyCon]
- ifDFun :: IfExtName
- ifOFlag :: OverlapFlag
- ifInstOrph :: IsOrphan
- ifInstWarn :: Maybe IfaceWarningTxt

#### Instances

Instances details

NFData IfaceClsInst # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceClsInst -> () #
Binary IfaceClsInst # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceClsInst -> IO () # put :: BinHandle -> IfaceClsInst -> IO (Bin IfaceClsInst) # get :: BinHandle -> IO IfaceClsInst #
Outputable IfaceClsInst # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceClsInst -> SDoc #

data IfaceFamInst #

Constructors

IfaceFamInst |

Fields

- ifFamInstFam :: IfExtName
- ifFamInstTys :: [Maybe IfaceTyCon]
- ifFamInstAxiom :: IfExtName
- ifFamInstOrph :: IsOrphan

#### Instances

Instances details

NFData IfaceFamInst # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceFamInst -> () #
Binary IfaceFamInst # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceFamInst -> IO () # put :: BinHandle -> IfaceFamInst -> IO (Bin IfaceFamInst) # get :: BinHandle -> IO IfaceFamInst #
Outputable IfaceFamInst # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceFamInst -> SDoc #

data IfaceTickish #

Constructors

IfaceHpcTick Module Int |
IfaceSCC CostCentre Bool Bool |
IfaceSource RealSrcSpan FastString |
IfaceBreakpoint Int [IfaceExpr] Module |

#### Instances

Instances details

NFData IfaceTickish # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceTickish -> () #
Binary IfaceTickish # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceTickish -> IO () # put :: BinHandle -> IfaceTickish -> IO (Bin IfaceTickish) # get :: BinHandle -> IO IfaceTickish #

data IfaceClassBody #

Constructors

IfAbstractClass |
IfConcreteClass |

Fields

- ifClassCtxt :: IfaceContext
- ifATs :: [IfaceAT]
- ifSigs :: [IfaceClassOp]
- ifMinDef :: IfaceBooleanFormula

#### Instances

Instances details

NFData IfaceClassBody # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceClassBody -> () #

data IfaceBooleanFormula #

Constructors

IfVar IfLclName |
IfAnd [IfaceBooleanFormula] |
IfOr [IfaceBooleanFormula] |
IfParens IfaceBooleanFormula |

#### Instances

Instances details

NFData IfaceBooleanFormula # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceBooleanFormula -> () #
Binary IfaceBooleanFormula # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceBooleanFormula -> IO () # put :: BinHandle -> IfaceBooleanFormula -> IO (Bin IfaceBooleanFormula) # get :: BinHandle -> IO IfaceBooleanFormula #

data IfaceBang #

This corresponds to an HsImplBang; that is, the final implementation decision about the data constructor arg

Constructors

IfNoBang |
IfStrict |
IfUnpack |
IfUnpackCo IfaceCoercion |

#### Instances

Instances details

NFData IfaceBang # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceBang -> () #
Binary IfaceBang # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceBang -> IO () # put :: BinHandle -> IfaceBang -> IO (Bin IfaceBang) # get :: BinHandle -> IO IfaceBang #

data IfaceSrcBang #

This corresponds to HsSrcBang

Constructors

IfSrcBang SrcUnpackedness SrcStrictness |

#### Instances

Instances details

NFData IfaceSrcBang # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceSrcBang -> () #
Binary IfaceSrcBang # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceSrcBang -> IO () # put :: BinHandle -> IfaceSrcBang -> IO (Bin IfaceSrcBang) # get :: BinHandle -> IO IfaceSrcBang #

data SrcUnpackedness #

Source Unpackedness

What unpackedness the user requested

Constructors

SrcUnpack | {-# UNPACK #-} specified
SrcNoUnpack | {-# NOUNPACK #-} specified
NoSrcUnpack | no unpack pragma

#### Instances

Instances details

Data SrcUnpackedness # |

Instance details

Defined in Language.Haskell.Syntax.Basic

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> SrcUnpackedness -> c SrcUnpackedness #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c SrcUnpackedness #

toConstr :: SrcUnpackedness -> Constr #

dataTypeOf :: SrcUnpackedness -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c SrcUnpackedness) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c SrcUnpackedness) #

gmapT :: (forall b. Data b => b -> b) -> SrcUnpackedness -> SrcUnpackedness #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> SrcUnpackedness -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> SrcUnpackedness -> r #

gmapQ :: (forall d. Data d => d -> u) -> SrcUnpackedness -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> SrcUnpackedness -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> SrcUnpackedness -> m SrcUnpackedness #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> SrcUnpackedness -> m SrcUnpackedness #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> SrcUnpackedness -> m SrcUnpackedness #

Binary SrcUnpackedness # |
Instance details Defined in GHC.Core.DataCon Methods put_ :: BinHandle -> SrcUnpackedness -> IO () # put :: BinHandle -> SrcUnpackedness -> IO (Bin SrcUnpackedness) # get :: BinHandle -> IO SrcUnpackedness #
Outputable SrcUnpackedness # |
Instance details Defined in GHC.Core.DataCon Methods ppr :: SrcUnpackedness -> SDoc #
Eq SrcUnpackedness # |
Instance details Defined in Language.Haskell.Syntax.Basic Methods (==) :: SrcUnpackedness -> SrcUnpackedness -> Bool # (/=) :: SrcUnpackedness -> SrcUnpackedness -> Bool #

data SrcStrictness #

Source Strictness

What strictness annotation the user wrote

Constructors

SrcLazy | Lazy, ie `~`
SrcStrict | Strict, ie `!`
NoSrcStrict | no strictness annotation

#### Instances

Instances details

Data SrcStrictness # |

Instance details

Defined in Language.Haskell.Syntax.Basic

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> SrcStrictness -> c SrcStrictness #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c SrcStrictness #

toConstr :: SrcStrictness -> Constr #

dataTypeOf :: SrcStrictness -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c SrcStrictness) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c SrcStrictness) #

gmapT :: (forall b. Data b => b -> b) -> SrcStrictness -> SrcStrictness #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> SrcStrictness -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> SrcStrictness -> r #

gmapQ :: (forall d. Data d => d -> u) -> SrcStrictness -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> SrcStrictness -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> SrcStrictness -> m SrcStrictness #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> SrcStrictness -> m SrcStrictness #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> SrcStrictness -> m SrcStrictness #

Binary SrcStrictness # |
Instance details Defined in GHC.Core.DataCon Methods put_ :: BinHandle -> SrcStrictness -> IO () # put :: BinHandle -> SrcStrictness -> IO (Bin SrcStrictness) # get :: BinHandle -> IO SrcStrictness #
Outputable SrcStrictness # |
Instance details Defined in GHC.Core.DataCon Methods ppr :: SrcStrictness -> SDoc #
Eq SrcStrictness # |
Instance details Defined in Language.Haskell.Syntax.Basic Methods (==) :: SrcStrictness -> SrcStrictness -> Bool # (/=) :: SrcStrictness -> SrcStrictness -> Bool #

data IfaceAxBranch #

Constructors

IfaceAxBranch |

Fields

- ifaxbTyVars :: [IfaceTvBndr]
- ifaxbEtaTyVars :: [IfaceTvBndr]
- ifaxbCoVars :: [IfaceIdBndr]
- ifaxbLHS :: IfaceAppArgs
- ifaxbRoles :: [Role]
- ifaxbRHS :: IfaceType
- ifaxbIncomps :: [BranchIndex]

#### Instances

Instances details

NFData IfaceAxBranch # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceAxBranch -> () #
Binary IfaceAxBranch # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceAxBranch -> IO () # put :: BinHandle -> IfaceAxBranch -> IO (Bin IfaceAxBranch) # get :: BinHandle -> IO IfaceAxBranch #

data IfaceTyConParent #

Constructors

IfNoParent |
IfDataInstance IfExtName IfaceTyCon IfaceAppArgs |

#### Instances

Instances details

NFData IfaceTyConParent # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceTyConParent -> () #
Binary IfaceTyConParent # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceTyConParent -> IO () # put :: BinHandle -> IfaceTyConParent -> IO (Bin IfaceTyConParent) # get :: BinHandle -> IO IfaceTyConParent #
Outputable IfaceTyConParent # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceTyConParent -> SDoc #

data IfaceCompleteMatch #

Constructors

IfaceCompleteMatch [IfExtName] (Maybe IfaceTyCon) |

#### Instances

Instances details

NFData IfaceCompleteMatch # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceCompleteMatch -> () #
Binary IfaceCompleteMatch # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceCompleteMatch -> IO () # put :: BinHandle -> IfaceCompleteMatch -> IO (Bin IfaceCompleteMatch) # get :: BinHandle -> IO IfaceCompleteMatch #
Outputable IfaceCompleteMatch # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceCompleteMatch -> SDoc #

data IfaceLFInfo #

Iface type for LambdaFormInfo. Fields not relevant for imported Ids are omitted in this type.

Constructors

IfLFReEntrant !RepArity |
IfLFThunk !Bool !Bool |
IfLFCon !Name |
IfLFUnknown !Bool |
IfLFUnlifted |

#### Instances

Instances details

Binary IfaceLFInfo # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceLFInfo -> IO () # put :: BinHandle -> IfaceLFInfo -> IO (Bin IfaceLFInfo) # get :: BinHandle -> IO IfaceLFInfo #
Outputable IfaceLFInfo # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceLFInfo -> SDoc #

data IfaceTopBndrInfo #

Constructors

IfLclTopBndr IfLclName IfaceType IfaceIdInfo IfaceIdDetails |
IfGblTopBndr IfaceTopBndr |

#### Instances

Instances details

NFData IfaceTopBndrInfo # |
Instance details Defined in GHC.Iface.Syntax Methods rnf :: IfaceTopBndrInfo -> () #
Binary IfaceTopBndrInfo # |
Instance details Defined in GHC.Iface.Syntax Methods put_ :: BinHandle -> IfaceTopBndrInfo -> IO () # put :: BinHandle -> IfaceTopBndrInfo -> IO (Bin IfaceTopBndrInfo) # get :: BinHandle -> IO IfaceTopBndrInfo #
Outputable IfaceTopBndrInfo # |
Instance details Defined in GHC.Iface.Syntax Methods ppr :: IfaceTopBndrInfo -> SDoc #

# Binding names

type IfaceTopBndr = Name #

A binding top-level `Name` in an interface file (e.g. the name of an `IfaceDecl`).

putIfaceTopBndr :: BinHandle -> IfaceTopBndr -> IO () #

getIfaceTopBndr :: BinHandle -> IO IfaceTopBndr #

ifaceDeclImplicitBndrs :: IfaceDecl -> [OccName] #

visibleIfConDecls :: IfaceConDecls -> [IfaceConDecl] #

ifaceDeclFingerprints :: Fingerprint -> IfaceDecl -> [(OccName, Fingerprint)] #

fromIfaceBooleanFormula :: IfaceBooleanFormula -> BooleanFormula IfLclName #

fromIfaceWarnings :: IfaceWarnings -> Warnings GhcRn #

fromIfaceWarningTxt :: IfaceWarningTxt -> WarningTxt GhcRn #

freeNamesIfDecl :: IfaceDecl -> NameSet #

freeNamesIfRule :: IfaceRule -> NameSet #

freeNamesIfFamInst :: IfaceFamInst -> NameSet #

freeNamesIfConDecls :: IfaceConDecls -> NameSet #

pprIfaceExpr :: (SDoc -> SDoc) -> IfaceExpr -> SDoc #

Pretty Print an IfaceExpr

The first argument should be a function that adds parens in context that need an atomic value (e.g. function args)

pprIfaceDecl :: ShowSub -> IfaceDecl -> SDoc #

newtype AltPpr #

Constructors

AltPpr (Maybe (OccName -> SDoc)) |

data ShowSub #

Constructors

ShowSub |

Fields

- ss_how_much :: ShowHowMuch
- ss_forall :: ShowForAllFlag

data ShowHowMuch #

Constructors

ShowHeader AltPpr | Header information only, not rhs
ShowSome (Maybe (OccName -> Bool)) AltPpr | Show the declaration and its RHS. The `Maybe` predicate allows filtering of the sub-components which should be printing; any sub-components filtered out will be elided with `...`.
ShowIface | Everything including GHC-internal information (used in --show-iface)

#### Instances

Instances details

Outputable ShowHowMuch # |
Instance details Defined in GHC.Iface.Type Methods ppr :: ShowHowMuch -> SDoc #

showToIface :: ShowSub #

Show declaration and its RHS, including GHc-internal information (e.g. for `--show-iface`).

showToHeader :: ShowSub #

Show a declaration but not its RHS.